











                                    ECHOES
                                    ------

                             MIDI DELAY PROCESSOR

                              User's Guide V1.02

                       (C) Copyright 1990, 1991 Dale Ong

                              2915 Portulaca Ave.
                            Jacksonville, FL 32224







                                 INTRODUCTION
                                 ------------

          WHAT IS ECHOES

          Echoes is a MIDI "delay line". Rather than delaying an audio
          signal, Echoes will delay the MIDI data stream. Echoes can
          produce up to 8 "repeats" of the MIDI data it receives. Each
          repeat has individual control of delay time, MIDI channel,
          transposing, and velocity scaling. The result is a range of
          echo effects far greater than any audio delay line.
          Optionally you can write a format 1 MIDI file containing the
          incoming MIDI data and subsequent repeats.


          SYSTEM REQUIREMENTS

          To run Echoes you will need an IBM PC (or some variant)
          equipped with a Roland MPU-401 or compatible MIDI interface.
          A Microsoft or compatible mouse is supported, but not
          required. A hard disk is recommended for writing MIDI files.

          Echoes defaults to IRQ (interrupt request) 2 and an MPU base
          address of $330 (816 decimal). If you need to specify a
          different interrupt request line or MPU base address, you
          may pass the new configuration on the command line.

          To use Echoes on IRQ 3 you would type 'echoes /i3' and hit
          return. You may specify any IRQ line from 2 to 7. To run
          Echoes at a different base address, pass the new base
          address after the IRQ number.

          'echoes /i2 $300' would use IRQ2 at address $300 (768). You
          must pass an interrupt request line before the new MPU base
          address.

          NOTE: Echoes will lock-up if run on a system without a
          properly configured MPU-401.

          Consult your MPU owner's manual for more details on the base
          address and IRQ number.







          USER SUPPORT

          Echoes is user supported software! You are encouraged to use
          this software and distribute copies to your friends. If you
          find Echoes useful, you are also encouraged to send a $20
          contribution to help offset my cost of software development
          tools, and provide me with a modest reward for the enormous
          amount of time spent developing it.

          Those who support Echoes will be rewarded with good karma -
          and a copy of my "Arpegg-O-Matic" MIDI arpeggiator.

          Please address questions, comments, and contributions to:

               Dale Ong
               2915 Portulaca Avenue
               Jacksonville, FL 32224







                            WALK-THROUGH / TUTORIAL
                            -----------------------

          SYNTH SETUP

          For this walk-through let's set up our hardware the simplest
          way possible. Connect the MIDI output from your MIDI
          interface to the MIDI input of your keyboard. Likewise
          connect the MIDI output of your keyboard to your computer's
          MIDI input. Make sure that your keyboard is transmitting and
          receiving on channel 1.

          Let's start making music! Type "echoes" and hit RETURN. You
          should now see the Echoes screen. If you get the DOS message
          "Bad command or file name" DOS could not locate ECHOES.EXE.
          Make sure that you are logged onto the correct disk drive
          and/or directory.

          There are four main parts to the Echoes screen. Near the top
          is a horizontal menu. During some operations this menu will
          disappear and a DIALOG box will appear in its place. When
          all is well, the DIALOG box will be green. If there is a
          problem or if you should proceed with caution, the DIALOG
          box will be red.

          The three other sections (MASTER, REPEATS, and FILTER)
          contain the fields for editing the echo parameters. MASTER
          contains the fields that are "global" such as the preset
          name (currently DEFAULT), BPM (tempo), and the active MIDI
          CHANNEL. REPEATS is a matrix of the 8 repeats by the delay
          time, MIDI transmit channel, transpose, and velocity
          settings. FILTER contains fields for the MIDI status filters
          and channel reference tables. Don't be intimidated by all
          this now. We'll cover all the details later.

          To start the echo process select the "RUN" option of the
          MAIN MENU. You may make a menu selection in one of three
          ways: 1) Type the first letter of your selection. 2) Use the
          cursor keys to highlight your selection and hit RETURN. 3)
          Position the mouse cursor (eighth note) over your choice and
          click the left mouse button.

          The menu will be replaced by a DIALOG box saying "Running -
          Hit any key when done...". Play a few notes. Echoes will
          play back 8 repeats of your notes. When you are done
          playing, hit any key on the computer keyboard (or click any
          mouse button) to return to the MAIN MENU.







          LOADING PRESETS

          While DEFAULT shows the basic operation of Echoes, it
          doesn't show any of the more advanced features. Let's LOAD
          another preset and get into the good stuff.

          From the MAIN MENU select FILES. This calls the FILES MENU.
          Select the LOAD option. A "pick list" of presets appears on
          top of the menu. Now select the file called "NUTRON". This
          is done much like selecting a menu item. You can use the
          cursor keys to highlight NUTRON and hit return, or position
          the mouse cursor over NUTRON and double click the left mouse
          button.

          Pressing the first letter of the preset name will take you
          to the first preset beginning with that letter. Subsequent
          key presses will highlight other presets beginning with that
          letter.

          Once you LOAD NUTRON you will be returned to the MAIN MENU.
          Select RUN again and play a few notes. Now this is what
          Echoes is all about! NUTRON uses the repeats to set up a
          complex rhythmic structure and transposes some notes in a
          melodic fashion. The result is like a souped-up arpeggiator.

          If you like, take the time now to LOAD and RUN some other
          presets. For a long delay try SWEET-16! A conventional audio
          delay would need a lot of memory for delays this long!


          EDITING

          The presets included with Echoes represent many of the
          things that you can do with Echoes but at some point
          (probably by now) you will want to create your own presets.
          LOAD DEFAULT again and we'll try our hand at editing.

          From the MAIN MENU select the EDIT option. A DIALOG box will
          display the message "Editing - Hit ESC key when done...",
          and the currently selected field (preset name) will be
          highlighted.







          ON-LINE HELP

          Before we actually edit anything, this is a good time to
          introduce the on line help system. The help system is
          context sensitive, that is, it will try to offer help
          appropriate to your location in the program.

          To activate the help system press the F1 key or click both
          the left and right mouse buttons simultaneously. Pressing F1
          or clicking both mouse buttons again will display a pick
          list of help topics. Some help screens will have a
          highlighted word to take you to another cross-referenced
          help screen. to exit the help system press the ESC key or
          click the right mouse button.

          There are two very different methods of editing depending on
          whether you are using the keyboard or a mouse...


          KEYBOARD EDITING

          To edit from the keyboard select the field you want to edit
          with the cursor keys. If you prefer you may successively hit
          the RETURN key until you reach the desired field. Once you
          have the desired field highlighted, use the "+" and "-" keys
          to increment or decrement the value. You may then select
          another field for editing. After your last edit, you must
          hit RETURN or use the cursor keys to select another field to
          "set" the last edit. Then hit the ESC key to quit editing. A
          shortcut here is to hit the PG-UP or PG-DN key which will
          set the last edit and return to the MAIN MENU.

          If you are editing from the keyboard, you will benefit
          greatly from using a keyboard speed-up utility.


          MOUSE EDITING

          Mouse editing allows you to do all of your edits without
          ever touching the keyboard! First select the field you want
          to edit by positioning the mouse cursor over the value you
          wish to change and clicking the left mouse button. The mouse
          cursor will disappear and the field will highlight. Now you
          can increment or decrement the value by moving the mouse to
          the right or left. When you have "dialed in" the desired
          value, click the left mouse button to set the field. The
          mouse cursor will reappear and you may now select another
          field to edit or click the right button if you are done.







          CREATING PRESETS

          Enough talk let's start editing! We'll assume that we will
          create a preset worthy of saving so let's start by changing
          the preset name. Okay mouse user's we lied - you can't dial
          in a new name. For this one field you will have to use the
          keyboard.

          Here, and elsewhere, Echoes provides a simple but effective
          line editor. The line editor commands should be old hat to
          anyone with word processing experience:

          ENTER - Accepts line.
          ESC - Quit without editing.
          LEFT - Move cursor left one character.
          RIGHT - Move cursor right one character.
          HOME - Move cursor to beginning of line.
          END - Move cursor to end of line.
          DEL - Delete character at cursor.
          BKSP - Delete character left of cursor.
          INS - Toggles between insert and overwrite.

          Lets name our new pattern "SIMPLE" since we won't get too
          complex just yet.

          Next, let's set the REPEATS field to 5 repeats. This means
          that the phrase will be six notes long (You play one and
          Echoes will play the other five).

          Now we'll set the rhythmic structure. Before we change any
          values, let's look at how Echoes stores the numbers in the
          TIME fields...







          TIME NOTATION IN ECHOES

          In MIDI, quarter notes always get the beat. A beat is
          divided into 24 MIDI "clocks". If you're ahead of me, you've
          already calculated that a MIDI clock equals one part of a
          sixty-fourth note triplet (Three clocks equal a 32nd note,
          six clocks is a 16th note, and twelve clocks is an 8th
          note). In Echoes the time value is set in a BEATS:CLOCKS
          format.

          It is also important to remember that the time settings do
          not set the note duration, but rather the time delay after
          the previous note. Thus, if the 1st repeat has a TIME
          setting of 1:00, it will sound one beat after you play a
          note.

          Let's set the 2nd repeat to sound an 8th note after the 1st
          repeat. Select the TIME field for the second repeat and set
          the value to 0:12 (0 beats and 12 MIDI clocks = an 8th
          note). Now set the TIME fields for repeats 3 and 4 to 8th
          notes (0:12) too.


          TRANSPOSING

          Now lets add some melodic variation. Set the TRANS field for
          the 2nd repeat to 12. This means that the 2nd repeat will
          play a note an octave (12 semitones) higher than the pitch
          you play. Set the TRANS field for the 4th repeat to 7. This
          will make the 4th repeat play a fifth higher. Now return to
          the MAIN MENU and RUN the new pattern.

          How about that! You've just created your first new echo
          pattern, but its not a preset yet...


          SAVING PRESETS

          In order to LOAD this pattern later you'll need to save it
          to disk. From the MAIN MENU select the FILES option. Now
          select SAVE from the FILES MENU. Now your pattern is a
          bonafide preset that you can LOAD later!


          QUITTING

          To QUIT Echoes select the QUIT option from the MAIN MENU.
          You will be asked if this is really your intention (stop and
          think, have I saved any edits?) To accept the default of no,
          hit RETURN or click the left mouse button. If you are indeed
          ready to QUIT hit "Y".







                                 MENU CHOICES
                                 ------------

          MAIN MENU

          FILES - calls the FILES MENU. The FILES MENU provides access
          to your computer's disk drives.

          RUN - starts the real-time processing of incoming MIDI data.
          Data will be echoed according to the current parameters of
          the MASTER, REPEATS, and FILTER sections.

          WRITE - same as RUN, but Echoes will create a format 1 MIDI
          file. When you are playing, Echoes writes a temporary file
          containing only the MIDI data received. When you stop, a
          DIALOG box asks if you want to convert the temporary file to
          a MIDI file. If you proceed, another DIALOG box suggests a
          name for the MIDI file (the name of the current preset with
          the extension "MID" for MIDI file). You may accept the
          default file name or use the LINE EDITOR to edit it to your
          liking. Track 1 of the MIDI file contains the data received,
          while tracks 2-9 contain repeats 1-8.

          EDIT - allows you to change the echo parameters.

          QUIT - leaves Echoes and returns to the Disk Operating
          System.


          FILES MENU

          LOAD - displays a pick list of available presets.

          SAVE - creates a new preset of the current echo parameters.
          If there is already a preset with this name, a DIALOG box
          will ask you to confirm overwriting.

          ERASE - displays a pick list of available presets. A DIALOG
          box will ask you to confirm the ERASE operation.

          PATH - changes to a new disk drive and/or directory. LOAD,
          SAVE, and ERASE commands will all be relative to the new
          PATH. In addition, any MIDI files created with the WRITE
          option will reside on the new path. A DIALOG box will
          display the current PATH which you can edit with the LINE
          EDITOR.

          DOS - a DOS shell. This will temporarily suspend Echoes and
          return you to the Disk Operating System where you may run
          another program. To return to Echoes, enter "EXIT" at the
          DOS prompt.







                               MASTER PARAMETERS
                               -----------------

          FILENAME

          The first parameter in the MASTER section is the name of the
          active preset. Preset names may be any DOS-legal filename
          (avoid characters which have special meaning to DOS such as
          \ ? and *). All presets have the common DOS extension "EKO".


          BPM

          BPM is the tempo in beats per minute. Together with the TIME
          settings, BPM determines the absolute delay time of repeats
          in a manner which makes it easy to change tempo and still
          have repeats play in sync with the rest of your music. The
          tempo may range from 8 - 240 beats per minute. At the
          extreme slow end there are also settings for EXT (external
          MIDI clock) and FSK (tape sync).


          REPEATS

          REPEATS sets the number of repeats which Echoes will play.
          You may select from 1 - 8 repeats of incoming MIDI data.


          CHANNEL

          CHANNEL is Echoes active MIDI channel. All MIDI data on
          other channels will be ignored.


          THRU

          THRU is an ON-OFF switch controlling the MIDI thru status of
          the MIDI interface. If THRU is ON, MIDI data received at the
          MIDI input will be passed directly to the MIDI output in
          addition to being processed by Echoes. Generally you will
          want THRU ON when you are using a master keyboard with
          outboard tone generators.


          TICKS

          TICKS has minimal effect when you RUN Echoes. When you WRITE
          a MIDI file, TICKS sets the timing resolution (ppq) of the
          file. Although the range is from 48 - 192, we suggest using
          the default resolution of the software you plan to export
          the MIDI file to. When in doubt, set TICKS to 96.







                               REPEAT PARAMETERS
                               -----------------

          TIME

          TIME sets the time delay from the previous repeat (or note
          played in the case of the 1st repeat). Time is stored in a
          BEATS:CLOCKS format. Valid TIME settings for repeats 2 - 8
          range from 0:00 to 32:00. The 1st repeat must have a delay
          time of at least 0:01.


          CHAN

          CHAN sets the MIDI transmission channel for a repeat. CHAN
          may be set to any of the sixteen MIDI channels. At the
          lowest setting, channelizing is disabled and no number is
          displayed.


          TRANS

          TRANS sets the transposition for a repeat. TRANS is set in
          half steps from -60 - 60 (down five octaves to up five
          octaves). If a repeat isn't transposed, no number will be
          displayed. If a transposed note falls out of the range of
          MIDI it will be "wrapped around" to the nearest legal
          octave.


          VEL

          VEL controls the velocity scaling for a repeat. Velocity may
          be scaled from 1 - 200 percent. Note on velocity is clipped
          to between 1 and 127. A note-on command with a velocity of 0
          is interpreted as a note-off, so Echoes will always transmit
          a note-on velocity of at least 1.







                           FILTER PARAMETERS
                           -----------------

          FILTERS

          The five MIDI status filters (POLY PRESS, CONTROLLER,
          PROGRAM, CHAN PRESS, and PITCH BEND) can remove MIDI data
          with these status codes. The logic of the status filters is
          that when the status is ON, these MIDI messages are echoed.
          If the status is OFF, the data is filtered.


          CRT'S

          CRT'S are channel reference tables. CRT'S determine how a
          note is played if that note is already sounding.

          The MPU has four CRT'S where keeps track of what notes are
          currently on for four different MIDI channels. If a
          duplicate note-on message is sent on a channel with an
          active CRT, the MPU will send a note-off command immediately
          followed by another note-on command. This helps overcome
          problems of the MPU attempting to play more notes than your
          keyboard can produce simultaneously.

          If all 8 repeats for a simple 3 note chord overlap, the MPU
          will be playing 27 notes at once! (Don't forget the notes
          you play.) Few keyboards can handle that many notes.

          If you notice that a MIDI file created with Echoes sounds
          different when played by a sequencer than it did when you
          recorded it, it means that the sequencer uses (or doesn't
          use) the CRT'S in a different manner. To disable the CRT'S,
          set them to inactive MIDI transmit channels.

          Also note that some MPU clones vary in their implementation
          of CRT'S. Please consult your MPU and sequencer
          documentation for more details.








                                  LIMITATIONS


          METRONOME

          By now you've probably noticed the absence of a metronome,
          and we agree that it would be a useful thing to have. The
          bad news is that we've asked the MPU to do some unusual
          things to produce the delays and it now refuses to give us
          one! Don't worry. If you have a MIDI drum machine, we can
          use it for our metronome.

          Echoes sends MIDI clocks and start / stop commands. If a
          drum machine is set to sync to an external MIDI clock, it
          makes a fine metronome - actually much better than the MPU.

          If you prefer, you can set Echoes to sync to an external
          MIDI clock. Just set the BPM to EXT and RUN your preset.
          When you start your drum machine, Echoes will follow along
          in perfect sync.


          MIDI

          MIDI imposes some real-world limitations on Echoes. Remember
          that Echoes routinely has to transmit 8 times more data than
          receives. Although all of the PC / MPU communications
          routines are written in 100% hand optimized assembly code,
          if Echoes receives too much data too quickly, some time
          skewing may occur.

          Don't panic, in practical applications we have never
          experienced any skewing, but you should be aware that the
          potential is there.

          If you do have problems with skewing, try using the status
          filters to remove any unneeded data. Better yet, don't even
          send it - filter it at the source.







                             COMPOSING WITH ECHOES
                             ---------------------

          Echoes is much more than just an effects unit. When you
          create a preset with structured rhythms, melodic
          transposing, and velocity scaled dynamics, the results can
          lead you to new musical expressions. Throw in MIDI file
          exporting and you have a powerful compositional tool.

          In general, you should use Echoes to rough-out musical
          ideas. A MIDI file may then be imported into a sequencer for
          further development.

          With many overlapping repeats, things may quickly become too
          dense. Longer, slower phrases are generally better suited to
          your playing notes throughout the phrase. If Echoes is
          producing a short, fast phrase, you may want to let each
          phrase complete before hitting any more keys. Don't be
          afraid to let Echoes play most of the notes!

          If you are doing a lot of transposing, you may get better
          results by playing with a more open voicing. Conversely,
          presets that transpose with an open voicing give you a
          little more freedom in the notes you play.

          For something completely different, try using Echoes with a
          MIDI drum machine that receives note-on commands. Your drum
          patterns will never be the same!

